diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/ht/ht-frame-exchange-manager.cc ns-3.45/src/wifi/model/ht/ht-frame-exchange-manager.cc
--- ns-3.44/src/wifi/model/ht/ht-frame-exchange-manager.cc	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/ht/ht-frame-exchange-manager.cc	2025-06-01 20:34:45.619702300 -0700
@@ -624,18 +624,21 @@
         }
     }
 
-    if (selectedBar && selectedBar->GetHeader().GetAddr2() != m_self)
+    if (selectedBar)
     {
-        // the selected BAR has MLD addresses in Addr1/Addr2, replace them with link addresses
-        // and move to the appropriate container queue
-        NS_ASSERT(selectedBar->GetHeader().GetAddr2() == m_mac->GetAddress());
-        DequeueMpdu(selectedBar);
-        const auto currAddr1 = selectedBar->GetHeader().GetAddr1();
-        auto addr1 =
-            GetWifiRemoteStationManager()->GetAffiliatedStaAddress(currAddr1).value_or(currAddr1);
-        selectedBar->GetHeader().SetAddr1(addr1);
-        selectedBar->GetHeader().SetAddr2(m_self);
-        queue->Enqueue(selectedBar);
+        if (const auto currAddr1 = selectedBar->GetHeader().GetAddr1();
+            currAddr1 == m_mac->GetMldAddress(currAddr1))
+        {
+            // the selected BAR has MLD addresses in Addr1/Addr2, replace them with link addresses
+            // and move to the appropriate container queue
+            DequeueMpdu(selectedBar);
+            const auto addr1 =
+                GetWifiRemoteStationManager()->GetAffiliatedStaAddress(currAddr1).value_or(
+                    currAddr1);
+            selectedBar->GetHeader().SetAddr1(addr1);
+            selectedBar->GetHeader().SetAddr2(m_self);
+            queue->Enqueue(selectedBar);
+        }
     }
 
     return selectedBar;
@@ -1031,19 +1034,28 @@
     NS_LOG_FUNCTION(this << txDuration << &txParams);
 
     NS_ASSERT(m_edca);
+    NS_ASSERT(txParams.m_acknowledgment &&
+              txParams.m_acknowledgment->acknowledgmentTime.has_value());
+
+    const auto singleDurationId = *txParams.m_acknowledgment->acknowledgmentTime;
 
     if (m_edca->GetTxopLimit(m_linkId).IsZero())
     {
-        NS_ASSERT(txParams.m_acknowledgment &&
-                  txParams.m_acknowledgment->acknowledgmentTime.has_value());
-        return *txParams.m_acknowledgment->acknowledgmentTime;
+        return singleDurationId;
     }
 
     // under multiple protection settings, if the TXOP limit is not null, Duration/ID
     // is set to cover the remaining TXOP time (Sec. 9.2.5.2 of 802.11-2016).
     // The TXOP holder may exceed the TXOP limit in some situations (Sec. 10.22.2.8
     // of 802.11-2016)
-    return std::max(m_edca->GetRemainingTxop(m_linkId) - txDuration, Seconds(0));
+    auto duration = std::max(m_edca->GetRemainingTxop(m_linkId) - txDuration, Seconds(0));
+
+    if (m_protectSingleExchange)
+    {
+        duration = std::min(duration, singleDurationId + m_singleExchangeProtectionSurplus);
+    }
+
+    return duration;
 }
 
 void
@@ -1123,7 +1135,7 @@
         return;
     }
 
-    DoCtsTimeout(m_psdu);
+    DoCtsTimeout(WifiPsduMap{{SU_STA_ID, m_psdu}});
     m_psdu = nullptr;
 }
 
@@ -1364,14 +1376,8 @@
         txVector.SetAggregation(true);
     }
 
-    auto txDuration = WifiPhy::CalculateTxDuration(psdu, txVector, m_phy->GetPhyBand());
-    // The TXNAV timer is a single timer, shared by the EDCAFs within a STA, that is initialized
-    // with the duration from the Duration/ID field in the frame most recently successfully
-    // transmitted by the TXOP holder, except for PS-Poll frames. (Sec.10.23.2.2 IEEE 802.11-2020)
-    if (!psdu->GetHeader(0).IsPsPoll())
-    {
-        m_txNav = Max(m_txNav, Simulator::Now() + txDuration + psdu->GetDuration());
-    }
+    const auto txDuration = WifiPhy::CalculateTxDuration(psdu, txVector, m_phy->GetPhyBand());
+    SetTxNav(*psdu->begin(), txDuration);
 
     m_phy->Send(psdu, txVector);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/ht/ht-operation.cc ns-3.45/src/wifi/model/ht/ht-operation.cc
--- ns-3.44/src/wifi/model/ht/ht-operation.cc	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/ht/ht-operation.cc	2025-06-01 20:34:45.619702300 -0700
@@ -54,18 +54,20 @@
 void
 HtOperation::Print(std::ostream& os) const
 {
-    os << "HT Operation=" << bool(GetPrimaryChannel()) << "|" << +GetSecondaryChannelOffset() << "|"
-       << bool(GetStaChannelWidth()) << "|" << bool(GetRifsMode()) << "|" << +GetHtProtection()
-       << "|" << bool(GetNonGfHtStasPresent()) << "|" << bool(GetObssNonHtStasPresent()) << "|"
-       << bool(GetDualBeacon()) << "|" << bool(GetDualCtsProtection()) << "|"
-       << bool(GetStbcBeacon()) << "|" << bool(GetLSigTxopProtectionFullSupport()) << "|"
-       << bool(GetPcoActive()) << "|" << bool(GetPhase()) << "|" << GetRxHighestSupportedDataRate()
-       << "|" << bool(GetTxMcsSetDefined()) << "|" << bool(GetTxRxMcsSetUnequal()) << "|"
-       << +GetTxMaxNSpatialStreams() << "|" << bool(GetTxUnequalModulation()) << "|";
+    os << "HT Operation=[Primary Channel: " << +m_primaryChannel
+       << ", Secondary Channel Offset: " << +m_secondaryChannelOffset
+       << ", STA Channel Width: " << +m_staChannelWidth << ", HT Protection: " << +m_htProtection
+       << ", OBSS NON HT STAs Present: " << +m_obssNonHtStasPresent
+       << ", L-SIG TXOP Protection Full Support: " << +m_lSigTxopProtectionFullSupport
+       << ", RX Highest Supported Data Rate: " << m_rxHighestSupportedDataRate << ", MCS Set: {";
     for (uint8_t i = 0; i < MAX_SUPPORTED_MCS; i++)
     {
-        os << IsSupportedMcs(i) << " ";
+        if (IsSupportedMcs(i))
+        {
+            os << +i << " ";
+        }
     }
+    os << "}]";
 }
 
 uint16_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/ht/ht-operation.h ns-3.45/src/wifi/model/ht/ht-operation.h
--- ns-3.44/src/wifi/model/ht/ht-operation.h	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/ht/ht-operation.h	2025-06-01 20:34:45.619702300 -0700
@@ -33,7 +33,7 @@
  * @brief The HT Operation Information Element
  * @ingroup wifi
  *
- * This class knows how to serialise and deserialise
+ * This class knows how to serialize and deserialize
  * the HT Operation Information Element
  */
 class HtOperation : public WifiInformationElement
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/ht/ht-phy.cc ns-3.45/src/wifi/model/ht/ht-phy.cc
--- ns-3.44/src/wifi/model/ht/ht-phy.cc	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/ht/ht-phy.cc	2025-06-01 20:34:45.619702300 -0700
@@ -40,6 +40,13 @@
                              WIFI_PPDU_FIELD_DATA } }
 };
 
+/**
+ * \brief map a given secondary channel width to its channel list type
+ */
+const std::map<MHz_u, WifiChannelListType> htSecondaryChannels {
+    {20, WIFI_CHANLIST_SECONDARY},
+};
+
 // clang-format on
 
 HtPhy::HtPhy(uint8_t maxNss /* = 1 */, bool buildModeList /* = true */)
@@ -312,8 +319,8 @@
     case LAST_MPDU_IN_AGGREGATE: {
         // last packet in an A-MPDU
         uint32_t totalSize = totalAmpduSize + size;
-        numSymbols = lrint(
-            stbc * ceil((service + totalSize * 8.0 + 6 * nes) / (stbc * numDataBitsPerSymbol)));
+        numSymbols =
+            stbc * ceil((service + totalSize * 8.0 + 6 * nes) / (stbc * numDataBitsPerSymbol));
         NS_ASSERT(totalAmpduNumSymbols <= numSymbols);
         numSymbols -= totalAmpduNumSymbols;
         if (incFlag)
@@ -329,7 +336,7 @@
         // The number of OFDM symbols in the data field when BCC encoding
         // is used is given in equation 19-32 of the IEEE 802.11-2016 standard.
         numSymbols =
-            lrint(stbc * ceil((service + size * 8.0 + 6.0 * nes) / (stbc * numDataBitsPerSymbol)));
+            stbc * ceil((service + size * 8.0 + 6.0 * nes) / (stbc * numDataBitsPerSymbol));
         break;
     }
     default:
@@ -813,6 +820,71 @@
     return 65535;
 }
 
+const std::map<MHz_u, WifiChannelListType>&
+HtPhy::GetCcaSecondaryChannels() const
+{
+    return htSecondaryChannels;
+}
+
+std::vector<MHz_u>
+HtPhy::GetCcaSecondaryWidths(const Ptr<const WifiPpdu> ppdu) const
+{
+    std::vector<MHz_u> secondaryWidthsToCheck{};
+    if (ppdu)
+    {
+        for (const auto& secondaryChannel : GetCcaSecondaryChannels())
+        {
+            const auto secondaryWidth = secondaryChannel.first;
+            if (secondaryWidth >= m_wifiPhy->GetChannelWidth())
+            {
+                break;
+            }
+            const MHz_u secondaryMinFreq =
+                m_wifiPhy->GetOperatingChannel().GetSecondaryChannelCenterFrequency(
+                    secondaryWidth) -
+                (secondaryWidth / 2);
+            const MHz_u secondaryMaxFreq =
+                m_wifiPhy->GetOperatingChannel().GetSecondaryChannelCenterFrequency(
+                    secondaryWidth) +
+                (secondaryWidth / 2);
+            if (ppdu->DoesOverlapChannel(secondaryMinFreq, secondaryMaxFreq))
+            {
+                secondaryWidthsToCheck.push_back(secondaryWidth);
+            }
+        }
+    }
+    else
+    {
+        for (MHz_u secondaryWidth = 20; secondaryWidth < m_wifiPhy->GetChannelWidth();
+             secondaryWidth *= 2)
+        {
+            secondaryWidthsToCheck.push_back(secondaryWidth);
+        }
+    }
+    return secondaryWidthsToCheck;
+}
+
+PhyEntity::CcaIndication
+HtPhy::GetCcaIndicationOnSecondary(const Ptr<const WifiPpdu> ppdu)
+{
+    const auto& secondaryChannels = GetCcaSecondaryChannels();
+    const auto secondaryWidthsToCheck = GetCcaSecondaryWidths(ppdu);
+    for (auto secondaryWidth : secondaryWidthsToCheck)
+    {
+        const auto channelType = secondaryChannels.at(secondaryWidth);
+
+        const auto ccaThreshold = GetCcaThreshold(ppdu, channelType);
+        const auto band = GetSecondaryBand(secondaryWidth);
+        if (const auto delayUntilCcaEnd = GetDelayUntilCcaEnd(ccaThreshold, band);
+            delayUntilCcaEnd.IsStrictlyPositive())
+        {
+            return std::make_pair(delayUntilCcaEnd, channelType);
+        }
+    }
+
+    return std::nullopt;
+}
+
 PhyEntity::CcaIndication
 HtPhy::GetCcaIndication(const Ptr<const WifiPpdu> ppdu)
 {
@@ -820,6 +892,7 @@
     {
         return OfdmPhy::GetCcaIndication(ppdu);
     }
+
     auto ccaThreshold = GetCcaThreshold(ppdu, WIFI_CHANLIST_PRIMARY);
     auto delayUntilCcaEnd = GetDelayUntilCcaEnd(ccaThreshold, GetPrimaryBand(MHz_u{20}));
     if (delayUntilCcaEnd.IsStrictlyPositive())
@@ -828,6 +901,7 @@
             delayUntilCcaEnd,
             WIFI_CHANLIST_PRIMARY); // if Primary is busy, ignore CCA for Secondary
     }
+
     if (ppdu)
     {
         const MHz_u primaryWidth{20};
@@ -847,24 +921,7 @@
         }
     }
 
-    const MHz_u secondaryWidth{20};
-    const MHz_u s20MinFreq =
-        m_wifiPhy->GetOperatingChannel().GetSecondaryChannelCenterFrequency(secondaryWidth) -
-        (secondaryWidth / 2);
-    const MHz_u s20MaxFreq =
-        m_wifiPhy->GetOperatingChannel().GetSecondaryChannelCenterFrequency(secondaryWidth) +
-        (secondaryWidth / 2);
-    if (!ppdu || ppdu->DoesOverlapChannel(s20MinFreq, s20MaxFreq))
-    {
-        ccaThreshold = GetCcaThreshold(ppdu, WIFI_CHANLIST_SECONDARY);
-        delayUntilCcaEnd = GetDelayUntilCcaEnd(ccaThreshold, GetSecondaryBand(MHz_u{20}));
-        if (delayUntilCcaEnd.IsStrictlyPositive())
-        {
-            return std::make_pair(delayUntilCcaEnd, WIFI_CHANLIST_SECONDARY);
-        }
-    }
-
-    return std::nullopt;
+    return GetCcaIndicationOnSecondary(ppdu);
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/ht/ht-phy.h ns-3.45/src/wifi/model/ht/ht-phy.h
--- ns-3.44/src/wifi/model/ht/ht-phy.h	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/ht/ht-phy.h	2025-06-01 20:34:45.619702300 -0700
@@ -461,6 +461,32 @@
     CcaIndication GetCcaIndication(const Ptr<const WifiPpdu> ppdu) override;
 
     /**
+     * Get the secondary channel widths and their corresponding channel list types that are
+     * supported by the PHY entity.
+     *
+     * @return the channel list type per supported secondary channel width
+     */
+    virtual const std::map<MHz_u, WifiChannelListType>& GetCcaSecondaryChannels() const;
+
+    /**
+     * Get the widths of the secondary channels to inspect for CCA indication.
+     *
+     * @param ppdu the incoming PPDU or nullptr for any signal
+     * @return the widths of the secondary channels to inspect for CCA indication
+     */
+    std::vector<MHz_u> GetCcaSecondaryWidths(const Ptr<const WifiPpdu> ppdu) const;
+
+    /**
+     * Get CCA end time and its corresponding channel list type when a new signal not occupying the
+     * primary 20 MHz channel has been received by the PHY.
+     *
+     * @param ppdu the incoming PPDU or nullptr for any signal
+     * @return CCA end time and its corresponding channel list type or std::nullopt if all channel
+     * list types are IDLE
+     */
+    virtual PhyEntity::CcaIndication GetCcaIndicationOnSecondary(const Ptr<const WifiPpdu> ppdu);
+
+    /**
      * Build mode list.
      * Should be redone whenever the maximum MCS index per spatial stream
      * ,or any other important parameter having an impact on the MCS index
@@ -567,7 +593,7 @@
                                //!< MCS indices)
 
     static const PpduFormats m_htPpduFormats; //!< HT PPDU formats
-};                                            // class HtPhy
+};
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/ht/ht-ppdu.h ns-3.45/src/wifi/model/ht/ht-ppdu.h
--- ns-3.44/src/wifi/model/ht/ht-ppdu.h	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/ht/ht-ppdu.h	2025-06-01 20:34:45.619702300 -0700
@@ -109,7 +109,9 @@
         uint16_t m_htLength;   ///< HT length
         uint8_t m_aggregation; ///< Aggregation
         uint8_t m_sgi;         ///< Short Guard Interval
-    };                         // HtSigHeader
+
+        // end of class HtSigHeader
+    };
 
     /**
      * Create an HT PPDU.
@@ -172,7 +174,7 @@
                                    const HtSigHeader& htSig) const;
 
     HtSigHeader m_htSig; //!< the HT-SIG PHY header
-};                       // class HtPpdu
+};
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/interference-helper.cc ns-3.45/src/wifi/model/interference-helper.cc
--- ns-3.44/src/wifi/model/interference-helper.cc	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/interference-helper.cc	2025-06-01 20:34:45.619702300 -0700
@@ -795,19 +795,16 @@
 }
 
 InterferenceHelper::NiChanges::iterator
-InterferenceHelper::GetNextPosition(Time moment, NiChangesPerBand::iterator niIt)
+InterferenceHelper::GetNextPosition(Time moment, NiChangesPerBand::iterator niIt) const
 {
     return niIt->second.upper_bound(moment);
 }
 
 InterferenceHelper::NiChanges::iterator
-InterferenceHelper::GetPreviousPosition(Time moment, NiChangesPerBand::iterator niIt)
+InterferenceHelper::GetPreviousPosition(Time moment, NiChangesPerBand::iterator niIt) const
 {
-    auto it = GetNextPosition(moment, niIt);
-    // This is safe since there is always an NiChange at time 0,
-    // before moment.
-    --it;
-    return it;
+    // This is safe since there is always an NiChange at time 0, before moment.
+    return std::prev(GetNextPosition(moment, niIt));
 }
 
 InterferenceHelper::NiChanges::iterator
@@ -836,8 +833,7 @@
             continue;
         }
         NS_ASSERT(niIt->second.size() > 1);
-        auto it = GetPreviousPosition(endTime, niIt);
-        it--;
+        auto it = std::prev(GetPreviousPosition(endTime, niIt));
         m_firstPowers.find(niIt->first)->second = it->second.GetPower();
     }
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/interference-helper.h ns-3.45/src/wifi/model/interference-helper.h
--- ns-3.44/src/wifi/model/interference-helper.h	2025-03-09 16:55:49.791372500 -0700
+++ ns-3.45/src/wifi/model/interference-helper.h	2025-06-01 20:34:45.619702300 -0700
@@ -527,7 +527,7 @@
      * @param niIt iterator of the band to check
      * @returns an iterator to the list of NiChanges
      */
-    NiChanges::iterator GetNextPosition(Time moment, NiChangesPerBand::iterator niIt);
+    NiChanges::iterator GetNextPosition(Time moment, NiChangesPerBand::iterator niIt) const;
     /**
      * Returns an iterator to the last NiChange that is before than moment
      *
@@ -535,7 +535,7 @@
      * @param niIt iterator of the band to check
      * @returns an iterator to the list of NiChanges
      */
-    NiChanges::iterator GetPreviousPosition(Time moment, NiChangesPerBand::iterator niIt);
+    NiChanges::iterator GetPreviousPosition(Time moment, NiChangesPerBand::iterator niIt) const;
 
     /**
      * Add NiChange to the list at the appropriate position and
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/mgt-action-headers.cc ns-3.45/src/wifi/model/mgt-action-headers.cc
--- ns-3.44/src/wifi/model/mgt-action-headers.cc	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/mgt-action-headers.cc	2025-06-01 20:34:45.619702300 -0700
@@ -1767,7 +1767,8 @@
                 : (width == MHz_u{40})                     ? 1
                 : (width == MHz_u{80})                     ? 2
                 : (width == MHz_u{160})                    ? 3
-                                                           : 4;
+                : (width == MHz_u{320})                    ? 4
+                                                           : 5;
 }
 
 MHz_u
@@ -1783,6 +1784,8 @@
         return MHz_u{80};
     case 3:
         return MHz_u{160};
+    case 4:
+        return MHz_u{320};
     default:
         NS_ABORT_MSG("Reserved value: " << +m_chWidth);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/non-ht/dsss-parameter-set.cc ns-3.45/src/wifi/model/non-ht/dsss-parameter-set.cc
--- ns-3.44/src/wifi/model/non-ht/dsss-parameter-set.cc	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/non-ht/dsss-parameter-set.cc	2025-06-01 20:34:45.620702300 -0700
@@ -48,4 +48,10 @@
     return length;
 }
 
+void
+DsssParameterSet::Print(std::ostream& os) const
+{
+    os << "DSSS Parameter Set=[Current Channel: " << +m_currentChannel << "]";
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/non-ht/dsss-parameter-set.h ns-3.45/src/wifi/model/non-ht/dsss-parameter-set.h
--- ns-3.44/src/wifi/model/non-ht/dsss-parameter-set.h	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/non-ht/dsss-parameter-set.h	2025-06-01 20:34:45.620702300 -0700
@@ -18,7 +18,7 @@
  * @brief The DSSS Parameter Set
  * @ingroup wifi
  *
- * This class knows how to serialise and deserialise the DSSS Parameter Set.
+ * This class knows how to serialize and deserialize the DSSS Parameter Set.
  */
 class DsssParameterSet : public WifiInformationElement
 {
@@ -39,6 +39,7 @@
     uint16_t GetInformationFieldSize() const override;
     void SerializeInformationField(Buffer::Iterator start) const override;
     uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
+    void Print(std::ostream& os) const override;
 
     uint8_t m_currentChannel; ///< current channel number
 };
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/non-ht/dsss-phy.cc ns-3.45/src/wifi/model/non-ht/dsss-phy.cc
--- ns-3.44/src/wifi/model/non-ht/dsss-phy.cc	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/non-ht/dsss-phy.cc	2025-06-01 20:34:45.620702300 -0700
@@ -183,8 +183,7 @@
                             double& /* totalAmpduNumSymbols */,
                             uint16_t /* staId */) const
 {
-    return MicroSeconds(
-        lrint(ceil((size * 8.0) / (txVector.GetMode().GetDataRate(MHz_u{22}) / 1.0e6))));
+    return MicroSeconds(ceil((size * 8.0) / (txVector.GetMode().GetDataRate(MHz_u{22}) / 1.0e6)));
 }
 
 Ptr<WifiPpdu>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/non-ht/dsss-phy.h ns-3.45/src/wifi/model/non-ht/dsss-phy.h
--- ns-3.44/src/wifi/model/non-ht/dsss-phy.h	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/non-ht/dsss-phy.h	2025-06-01 20:34:45.620702300 -0700
@@ -199,7 +199,7 @@
     static const ModulationLookupTable
         m_dsssModulationLookupTable; //!< lookup table to retrieve code rate and constellation size
                                      //!< corresponding to a unique name of modulation
-};                                   // class DsssPhy
+};
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/non-ht/dsss-ppdu.h ns-3.45/src/wifi/model/non-ht/dsss-ppdu.h
--- ns-3.44/src/wifi/model/non-ht/dsss-ppdu.h	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/non-ht/dsss-ppdu.h	2025-06-01 20:34:45.620702300 -0700
@@ -70,7 +70,9 @@
       private:
         uint8_t m_rate;    ///< RATE field
         uint16_t m_length; ///< LENGTH field
-    };                     // class DsssSigHeader
+
+        // end of class DsssSigHeader
+    };
 
     /**
      * Create a DSSS (HR/DSSS) PPDU.
@@ -122,7 +124,7 @@
                                            const DsssSigHeader& dsssSig) const;
 
     DsssSigHeader m_dsssSig; //!< the DSSS SIG PHY header
-};                           // class DsssPpdu
+};
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/non-ht/erp-information.cc ns-3.45/src/wifi/model/non-ht/erp-information.cc
--- ns-3.44/src/wifi/model/non-ht/erp-information.cc	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/non-ht/erp-information.cc	2025-06-01 20:34:45.620702300 -0700
@@ -78,13 +78,12 @@
     return length;
 }
 
-std::ostream&
-operator<<(std::ostream& os, const ErpInformation& erpInformation)
+void
+ErpInformation::Print(std::ostream& os) const
 {
-    os << bool(erpInformation.GetBarkerPreambleMode()) << "|"
-       << bool(erpInformation.GetUseProtection()) << "|" << bool(erpInformation.GetNonErpPresent());
-
-    return os;
+    os << "ERP Information=[Barker Preamble Mode: " << GetBarkerPreambleMode()
+       << ", Use Protection: " << GetUseProtection() << ", Non ERP Present: " << GetNonErpPresent()
+       << "]";
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/non-ht/erp-information.h ns-3.45/src/wifi/model/non-ht/erp-information.h
--- ns-3.44/src/wifi/model/non-ht/erp-information.h	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/non-ht/erp-information.h	2025-06-01 20:34:45.620702300 -0700
@@ -18,7 +18,7 @@
  * @brief The ErpInformation Information Element
  * @ingroup wifi
  *
- * This class knows how to serialise and deserialise the ErpInformation Information Element.
+ * This class knows how to serialize and deserialize the ErpInformation Information Element.
  */
 class ErpInformation : public WifiInformationElement
 {
@@ -30,6 +30,7 @@
     uint16_t GetInformationFieldSize() const override;
     void SerializeInformationField(Buffer::Iterator start) const override;
     uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
+    void Print(std::ostream& os) const override;
 
     /**
      * Set the Barker_Preamble_Mode field in the ErpInformation information element.
@@ -74,16 +75,6 @@
     uint8_t m_erpInformation; ///< ERP information
 };
 
-/**
- * output stream output operator
- *
- * @param os output stream
- * @param erpInformation the ERP Information
- *
- * @returns output stream
- */
-std::ostream& operator<<(std::ostream& os, const ErpInformation& erpInformation);
-
 } // namespace ns3
 
 #endif /* ERP_INFORMATION_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/non-ht/erp-ofdm-phy.h ns-3.45/src/wifi/model/non-ht/erp-ofdm-phy.h
--- ns-3.44/src/wifi/model/non-ht/erp-ofdm-phy.h	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/non-ht/erp-ofdm-phy.h	2025-06-01 20:34:45.621702200 -0700
@@ -200,7 +200,7 @@
     static const ModulationLookupTable
         m_erpOfdmModulationLookupTable; //!< lookup table to retrieve code rate and constellation
                                         //!< size corresponding to a unique name of modulation
-};                                      // class ErpOfdmPhy
+};
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/non-ht/erp-ofdm-ppdu.h ns-3.45/src/wifi/model/non-ht/erp-ofdm-ppdu.h
--- ns-3.44/src/wifi/model/non-ht/erp-ofdm-ppdu.h	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/non-ht/erp-ofdm-ppdu.h	2025-06-01 20:34:45.621702200 -0700
@@ -50,7 +50,7 @@
 
   private:
     void SetTxVectorFromLSigHeader(WifiTxVector& txVector, const LSigHeader& lSig) const override;
-}; // class ErpOfdmPpdu
+};
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/non-ht/ofdm-phy.cc ns-3.45/src/wifi/model/non-ht/ofdm-phy.cc
--- ns-3.44/src/wifi/model/non-ht/ofdm-phy.cc	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/non-ht/ofdm-phy.cc	2025-06-01 20:34:45.621702200 -0700
@@ -260,8 +260,7 @@
 
     // The number of OFDM symbols in the data field when BCC encoding
     // is used is given in equation 19-32 of the IEEE 802.11-2016 standard.
-    double numSymbols =
-        lrint(ceil((GetNumberServiceBits() + size * 8.0 + 6.0) / (numDataBitsPerSymbol)));
+    double numSymbols = ceil((GetNumberServiceBits() + size * 8.0 + 6.0) / (numDataBitsPerSymbol));
 
     Time payloadDuration =
         FemtoSeconds(static_cast<uint64_t>(numSymbols * symbolDuration.GetFemtoSeconds()));
@@ -617,7 +616,7 @@
                            double codingRate)
 {
     double symbolRate = (1e9 / static_cast<double>(symbolDuration.GetNanoSeconds()));
-    return lrint(ceil(symbolRate * usableSubCarriers * numberOfBitsPerSubcarrier * codingRate));
+    return ceil(symbolRate * usableSubCarriers * numberOfBitsPerSubcarrier * codingRate);
 }
 
 uint16_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/non-ht/ofdm-phy.h ns-3.45/src/wifi/model/non-ht/ofdm-phy.h
--- ns-3.44/src/wifi/model/non-ht/ofdm-phy.h	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/non-ht/ofdm-phy.h	2025-06-01 20:34:45.621702200 -0700
@@ -443,7 +443,7 @@
     static const ModulationLookupTable
         m_ofdmModulationLookupTable; //!< lookup table to retrieve code rate and constellation size
                                      //!< corresponding to a unique name of modulation
-};                                   // class OfdmPhy
+};
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/non-ht/ofdm-ppdu.h ns-3.45/src/wifi/model/non-ht/ofdm-ppdu.h
--- ns-3.44/src/wifi/model/non-ht/ofdm-ppdu.h	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/non-ht/ofdm-ppdu.h	2025-06-01 20:34:45.621702200 -0700
@@ -74,7 +74,9 @@
       private:
         uint8_t m_rate;    ///< RATE field
         uint16_t m_length; ///< LENGTH field
-    };                     // class LSigHeader
+
+        // end of class LSigHeader
+    };
 
     /**
      * Create an OFDM PPDU.
@@ -128,7 +130,7 @@
 
     MHz_u m_channelWidth; //!< the channel width used to transmit that PPDU
                           //!< (needed to distinguish 5 MHz, 10 MHz or 20 MHz PPDUs)
-};                        // class OfdmPpdu
+};
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/phy-entity.cc ns-3.45/src/wifi/model/phy-entity.cc
--- ns-3.44/src/wifi/model/phy-entity.cc	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/phy-entity.cc	2025-06-01 20:34:45.621702200 -0700
@@ -785,7 +785,7 @@
 PhyEntity::RxPayloadFailed(Ptr<const WifiPsdu> psdu, double snr, const WifiTxVector& txVector)
 {
     NS_LOG_FUNCTION(this << *psdu << txVector << snr);
-    m_state->SwitchFromRxEndError();
+    m_state->SwitchFromRxEndError(txVector);
 }
 
 void
@@ -845,6 +845,27 @@
 }
 
 std::optional<Time>
+PhyEntity::GetTimeToPreambleDetectionEnd() const
+{
+    if (m_endPreambleDetectionEvents.empty())
+    {
+        return {};
+    }
+
+    std::optional<Time> delayUntilPreambleDetectionEnd;
+    for (const auto& endPreambleDetectionEvent : m_endPreambleDetectionEvents)
+    {
+        if (endPreambleDetectionEvent.IsPending())
+        {
+            delayUntilPreambleDetectionEnd =
+                std::max(delayUntilPreambleDetectionEnd.value_or(Time{0}),
+                         Simulator::GetDelayLeft(endPreambleDetectionEvent));
+        }
+    }
+    return delayUntilPreambleDetectionEnd;
+}
+
+std::optional<Time>
 PhyEntity::GetTimeToMacHdrEnd(uint16_t staId) const
 {
     const auto it = m_endOfMacHdrEvents.find(staId);
@@ -1181,12 +1202,6 @@
     m_endOfMacHdrEvents.clear();
 }
 
-bool
-PhyEntity::NoEndPreambleDetectionEvents() const
-{
-    return m_endPreambleDetectionEvents.empty();
-}
-
 void
 PhyEntity::CancelRunningEndPreambleDetectionEvents()
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/model/phy-entity.h ns-3.45/src/wifi/model/phy-entity.h
--- ns-3.44/src/wifi/model/phy-entity.h	2025-03-09 16:55:49.795372700 -0700
+++ ns-3.45/src/wifi/model/phy-entity.h	2025-06-01 20:34:45.621702200 -0700
@@ -401,21 +401,14 @@
      */
     virtual void CancelAllEvents();
     /**
-     * @return \c true if there is no end preamble detection event running, \c false otherwise
-     */
-    bool NoEndPreambleDetectionEvents() const;
-    /**
      * Cancel all end preamble detection events.
      */
     void CancelRunningEndPreambleDetectionEvents();
 
-    /**
-     * Get the remaining time to the end of the MAC header reception of the next MPDU being
-     * received from the given STA, if any.
-     *
-     * @param staId the STA-ID of the transmitter; equals SU_STA_ID for SU PPDUs
-     * @return the remaining time to the end of the MAC header reception of the next MPDU, if any
-     */
+    /// @copydoc WifiPhy::GetTimeToPreambleDetectionEnd
+    virtual std::optional<Time> GetTimeToPreambleDetectionEnd() const;
+
+    /// @copydoc WifiPhy::GetTimeToMacHdrEnd
     virtual std::optional<Time> GetTimeToMacHdrEnd(uint16_t staId) const;
 
     /**
@@ -972,7 +965,7 @@
                           //!< includes the noise figure)
 
     static uint64_t m_globalPpduUid; //!< Global counter of the PPDU UID
-};                                   // class PhyEntity
+};
 
 /**
  * @brief Stream insertion operator.
